import importlib
import os
import pickle
from pytracking.evaluation.environment import env_settings
import cv2
import numpy as np
import time
import torch
import argparse
import logging
import os.path as osp
import random

from pytracking.evaluation.otbdataset import OTBDataset
from DavisTester.davis_tester import DAVISTester

def get_parameters(tracker_name, param_file_name):
    param_module = importlib.import_module('pytracking.parameter.{}.{}'.format(tracker_name, param_file_name))
    params = param_module.parameters()
    return params

def read_image(image_file: str):
        return cv2.cvtColor(cv2.imread(image_file), cv2.COLOR_BGR2RGB)


if __name__ == '__main__':

####################################################################################

    #tracker_module_dmb = importlib.import_module('pytracking.tracker.{}'.format('DMB_gru_tracker'))
    #tracker_class_dmb = tracker_module_dmb.get_tracker_class()


###########################################################################################
    torch.backends.cudnn.benchmark = False

    tracker_module_dmb_train = importlib.import_module('pytracking.tracker.{}'.format('DMB_emd_tracker'))
    tracker_class_dmb_train = tracker_module_dmb_train.get_tracker_class()

    pth_path = os.path.join('/home/jaffe/PycharmProjects/DMB/pytracking/networks/logemd1_stm_track_dist_Noauthorinit_bz4/DAVIS16', 'recurrent11.pth.tar')  # got10k, vos:11
    # pth_path = '/home/jaffe/PycharmProjects/DMB/pytracking/networks/emd/recurrent1.pth.tar'
    param_module = importlib.import_module('pytracking.parameter.{}.{}'.format('DMB', 'DMB_emd_521_params_vos'))
    params = param_module.parameters(pth_path)
    dmb_train_tracker = tracker_class_dmb_train(params)

    #tracker_class = dmb_train_tracker

    all_tests = [] # d3s  stm_train_tracker_segnum_nobackb_epoch10_vot2019 stm_train_tracker stm_train_tracker_segnum_noAuthorinit_epoch11_vot2018
    print('run vot test')
    test_dataset = "DAVIS2017"  # "DAVIS2016"

    for i in range(1):
        #pth_name = 'SegmRaftNet_ep' + '%04d' % (i+50) + '.pth.tar'
        #pth_path = os.path.join('/home/jaffe/PycharmProjects/d3s_vos/workspace/wrap3/checkpoints/ltr/d3s_raft/d3s_raft_default', pth_name)
       # pth_path = os.path.join('/home/jaffe/PycharmProjects/DMB/pytracking/networks/gru_epoch7.pth.tar')
        #pth_path = os.path.join('/home/jaffe/PycharmProjects/DMB/pytracking/networks', 'recurrent'+str(i+15)+'.pth.tar')

        #param_module = importlib.import_module('pytracking.parameter.{}.{}'.format('DMB', 'DMB_gru_params'))
        #params = param_module.parameters(pth_path)
        test_tracker = dmb_train_tracker

        testname = 'aaa_davis16_result_emd'  # pth_path + 'result'
        #print(testname)
        all_tests.append(testname)
        testers1 = DAVISTester(test_tracker, test_dataset)
        testers1.test()







