from PIL import Image
import skimage
import numpy as np
import scipy
from skimage import morphology
import matplotlib.pyplot as plt
import os
def overlay(image,mask,cscale=6,alpha=0.4): # alpha=0.4    2
  """ Overlay segmentation on top of RGB image. """
  colors = []
  colors.append(np.atleast_2d([255,0,0]) * cscale) #偏红色

  colors.append(np.atleast_2d([0, 255, 0]) * cscale)# 绿色

  colors.append(np.atleast_2d([255, 165, 0]) * cscale)# 两种颜色

  colors.append(np.atleast_2d([255, 255, 0]) * cscale)# 亮黄色
  colors.append(np.atleast_2d([0, 255, 0]) * cscale) # 绿色
  colors.append(np.atleast_2d([192, 192, 192]) * cscale) #彩色
  colors.append(np.atleast_2d([255,0,0]) * cscale) #偏红色
  colors.append(np.atleast_2d([0, 0, 255]) * cscale) #深紫色
  colors.append(np.atleast_2d([0, 255, 255]) * cscale)
  colors.append(np.atleast_2d([255, 0, 255]) * cscale)
  colors.append(np.atleast_2d([255, 165, 0]) * cscale)
  colors.append(np.atleast_2d([160, 82, 45]) * cscale)
  colors.append(np.atleast_2d([255, 215, 0]) * cscale)
  colors.append(np.atleast_2d([192, 192, 192]) * cscale)
  #print(colors)

  im_overlay    = image.copy() # [w, h, 3]
  object_ids = np.unique(mask) # [0, 1, ]

  for object_id in object_ids:#[1:]:
    # Overlay color on  binary mask
    object_id = int(object_id)
    if object_id != 0:
      foreground  = image*alpha + np.ones(image.shape)*(1-alpha) * np.array(colors[object_id-1]) # np [h, w, 3]
      binary_mask = mask == object_id # [h, w]

      aa= morphology.binary.binary_dilation(binary_mask)
      # Compose image
      im_overlay[binary_mask] = foreground[binary_mask]


      #countours = morphology.binary.binary_dilation(binary_mask) - binary_mask
      countours = np.logical_xor(morphology.binary.binary_dilation(binary_mask), binary_mask)
      im_overlay[countours,:] = 0

  return im_overlay.astype(image.dtype)


address = "/home/jaffe/PycharmProjects/d3s_me/aaai/segm/ori/img/book/"
predict_address = "/home/jaffe/PycharmProjects/d3s_me/aaai/segm/ori/stm_train/book/"
save_dir = os.path.join(predict_address, 'visualize/')


if not os.path.exists(save_dir):
   os.mkdir(save_dir)
files = sorted(os.listdir(address))
files.sort()

for frame in sorted(os.listdir(address)):
  print(frame)
  img_path = os.path.join(address, frame)
  msk_path = os.path.join(predict_address, frame)
  msk_path = msk_path.replace('jpg','png')
  image = Image.open(img_path)
  image = np.asarray(image)#.reshape(1,3,480, 854)
  mask = Image.open(msk_path)
  mask = np.asarray(mask) #.reshape(1,1,480, 854)
  out = overlay(image, mask)
  out = Image.fromarray(out)
  if not os.path.exists(save_dir):
     os.makedirs(save_dir)
  out.save(os.path.join(save_dir , frame))